diff --git a/mobile/lib/screens/public_event/public_event_screen.dart b/mobile/lib/screens/public_event/public_event_screen.dart
index 9c8890e..2e2f3b3 100644
--- a/mobile/lib/screens/public_event/public_event_screen.dart
+++ b/mobile/lib/screens/public_event/public_event_screen.dart
@@ -147,41 +843,95 @@ class _PublicEventScreenState extends State<PublicEventScreen> {
     super.dispose();
   }
 
-  String _keyFor(String pid, int g) => pid + '-' + g.toString();
+  String _keyFor(String pid, int g) => '$pid-$g';
+  String _teamKey(int teamNumber) => 'team-$teamNumber';
 
-  void _onScoreChanged(PublicParticipant p, int gameNumber, String value) {
+  void _saveInlineScoreDebounced(
+    PublicParticipant p,
+    int gameNumber,
+    int score,
+  ) {
     final key = _keyFor(p.participantId, gameNumber);
-    _scoreStates[key] = 'idle';
-    // 3자리 입력 시 즉시 저장, 아니면 디바운스
+    _scoreStates[key] = 'saving';
+    setState(() {});
     _debouncers[key]?.cancel();
-    if (value.length == 3) {
-      final v = int.tryParse(value);
-      if (v != null && v >= 0 && v <= 300) {
-        _saveInlineScore(p, gameNumber, v);
-        return;
-      }
-    }
-    _debouncers[key] = Timer(const Duration(milliseconds: 200), () {
-      final v = int.tryParse(value);
-      if (v != null && v >= 0 && v <= 300) {
-        _saveInlineScore(p, gameNumber, v);
-      }
+    _debouncers[key] = Timer(const Duration(milliseconds: 500), () {
+      _saveInlineScore(p, gameNumber, score);
     });
   }
 
-  Future<void> _saveInlineScore(PublicParticipant p, int gameNumber, int score) async {
+  void _saveInlineHandicapDebounced(
+    PublicParticipant p,
+    int gameNumber,
+    int handicap,
+  ) {
+    final key = _keyFor(p.participantId, gameNumber);
+    _scoreStates[key] = 'saving';
+    setState(() {});
+    _debouncers[key]?.cancel();
+    _debouncers[key] = Timer(const Duration(milliseconds: 500), () {
+      _saveInlineHandicap(p, gameNumber, handicap);
+    });
+  }
+
+  void _saveTeamMemberScoreDebounced(
+    int teamNumber,
+    PublicTeamMemberSummary m,
+    int gameNumber,
+    int score,
+  ) {
+    final pid = m.participantId ?? '0';
+    final key = _keyFor(pid, gameNumber);
+    _scoreStates[key] = 'saving';
+    setState(() {});
+    _debouncers[key]?.cancel();
+    _debouncers[key] = Timer(const Duration(milliseconds: 500), () {
+      _saveTeamMemberScore(teamNumber, m, gameNumber, score);
+    });
+  }
+
+  void _saveTeamMemberHandicapDebounced(
+    int teamNumber,
+    PublicTeamMemberSummary m,
+    int gameNumber,
+    int handicap,
+  ) {
+    final pid = m.participantId ?? '0';
+    final key = _keyFor(pid, gameNumber);
+    _scoreStates[key] = 'saving';
+    setState(() {});
+    _debouncers[key]?.cancel();
+    _debouncers[key] = Timer(const Duration(milliseconds: 500), () {
+      _saveTeamMemberHandicap(teamNumber, m, gameNumber, handicap);
+    });
+  }
+
+  Future<void> _saveInlineScore(
+    PublicParticipant p,
+    int gameNumber,
+    int score,
+  ) async {
     final key = _keyFor(p.participantId, gameNumber);
     _scoreStates[key] = 'saving';
     setState(() {});
     try {
-      await _service.updateScore(widget.publicHash, participantId: p.participantId, gameNumber: gameNumber, score: score);
+      await _service.updateScore(
+        widget.publicHash,
+        participantId: p.participantId,
+        gameNumber: gameNumber,
+        score: score,
+      );
       // 로컬 모델 즉시 갱신
-      final idx = _participants.indexWhere((pp) => pp.participantId == p.participantId);
+      final idx = _participants.indexWhere(
+        (pp) => pp.participantId == p.participantId,
+      );
       if (idx >= 0) {
         final cur = _participants[idx];
         final newScores = List<int?>.from(cur.rawScores);
-        if (gameNumber >= 1 && gameNumber <= newScores.length) newScores[gameNumber - 1] = score;
-        _participants[idx] = PublicParticipant(
+        if (gameNumber >= 1 && gameNumber <= newScores.length) {
+          newScores[gameNumber - 1] = score;
+        }
+        final updated = PublicParticipant(
           participantId: cur.participantId,
           memberId: cur.memberId,
           name: cur.name,
@@ -196,6 +946,9 @@ class _PublicEventScreenState extends State<PublicEventScreen> {
           rawScores: newScores,
           handicaps: cur.handicaps,
         );
+        final newList = List<PublicParticipant>.from(_participants);
+        newList[idx] = updated;
+        _participants = newList;
       }
       _scoreStates[key] = 'saved';
       setState(() {});
@@ -205,12 +958,21 @@ class _PublicEventScreenState extends State<PublicEventScreen> {
         _scoreStates[key] = 'idle';
         setState(() {});
       });
+      // Debounced full sync load
+      _refreshDebounce?.cancel();
+      _refreshDebounce = Timer(const Duration(milliseconds: 400), () {
+        if (!mounted) return;
+        _load();
+      });
     } on DioException catch (e) {
       final status = e.response?.statusCode;
       if (status == 401 || status == 403) {
         if (!mounted) return;
         Navigator.of(context).pushReplacement(
-          MaterialPageRoute(builder: (_) => PublicEventEntryScreen(publicHash: widget.publicHash)),
+          MaterialPageRoute(
+            builder: (_) =>
+                PublicEventEntryScreen(publicHash: widget.publicHash),
+          ),
         );
         return;
       }
@@ -222,113 +984,6 @@ class _PublicEventScreenState extends State<PublicEventScreen> {
     }
   }
 
-  Future<void> _openScoreDialog(String participantId, {int? initial}) async {
-    final controller = TextEditingController(text: initial?.toString() ?? '');
-    int selectedGame = 1;
-    String? errorText;
-    final gameCount = _eventModel?.gameCount ?? 3;
-    final result = await showDialog<Map<String, int>?>(
-      context: context,
-      builder: (ctx) {
-        return StatefulBuilder(builder: (ctx2, setState) {
-          void validate() {
-            final v = int.tryParse(controller.text);
-            if (v == null || v < 0 || v > 300) {
-              setState(() => errorText = '0~300 사이의 정수를 입력하세요');
-            } else {
-              setState(() => errorText = null);
-            }
-          }
-          return AlertDialog(
-            title: const Text('점수 입력'),
-            content: Column(
-              mainAxisSize: MainAxisSize.min,
-              children: [
-                DropdownButton<int>(
-                  key: const Key('game_select'),
-                  value: selectedGame,
-                  items: [for (int i = 1; i <= gameCount; i++) DropdownMenuItem(value: i, child: Text('게임 ' + i.toString()))],
-                  onChanged: (v) => setState(() => selectedGame = v ?? 1),
-                ),
-                TextField(
-                  key: const Key('score_input'),
-                  controller: controller,
-                  keyboardType: TextInputType.number,
-                  decoration: InputDecoration(labelText: '점수(0-300)', errorText: errorText),
-                  onChanged: (_) => validate(),
-                ),
-              ],
-            ),
-            actions: [
-              TextButton(
-                onPressed: () => Navigator.of(ctx).pop(null),
-                child: const Text('취소'),
-              ),
-              ElevatedButton(
-                key: const Key('score_save_button'),
-                onPressed: () {
-                  final v = int.tryParse(controller.text);
-                  if (v == null || v < 0 || v > 300) {
-                    validate();
-                    return;
-                  }
-                  Navigator.of(ctx).pop({'game': selectedGame, 'score': v});
-                },
-                child: const Text('저장'),
-              ),
-            ],
-          );
-        });
-      },
-    );
-    if (result == null) return;
-    try {
-      final gameNumber = result['game']!;
-      final score = result['score']!;
-      await _service.updateScore(widget.publicHash, participantId: participantId, gameNumber: gameNumber, score: score);
-      if (!mounted) return;
-      // 로컬 모델 즉시 갱신
-      final idx = _participants.indexWhere((pp) => pp.participantId == participantId);
-      if (idx >= 0) {
-        final p = _participants[idx];
-        final newScores = List<int?>.from(p.rawScores);
-        if (gameNumber >= 1 && gameNumber <= newScores.length) {
-          newScores[gameNumber - 1] = score;
-          _participants[idx] = PublicParticipant(
-            participantId: p.participantId,
-            memberId: p.memberId,
-            name: p.name,
-            gender: p.gender,
-            memberType: p.memberType,
-            average: p.average,
-            handicap: p.handicap,
-            status: p.status,
-            paymentStatus: p.paymentStatus,
-            comment: p.comment,
-            isGuest: p.isGuest,
-            rawScores: newScores,
-            handicaps: p.handicaps,
-          );
-          setState(() {});
-        }
-      }
-      ScaffoldMessenger.of(context).showSnackBar(const SnackBar(content: Text('점수가 저장되었습니다')));
-    } on DioException catch (e) {
-      if (!mounted) return;
-      final status = e.response?.statusCode;
-      if (status == 401 || status == 403) {
-        Navigator.of(context).pushReplacement(
-          MaterialPageRoute(builder: (_) => PublicEventEntryScreen(publicHash: widget.publicHash)),
-        );
-        return;
-      }
-      ScaffoldMessenger.of(context).showSnackBar(SnackBar(content: Text('저장 실패: ' + e.toString())));
-    } catch (e) {
-      if (!mounted) return;
-      ScaffoldMessenger.of(context).showSnackBar(SnackBar(content: Text('저장 실패: ' + e.toString())));
-    }
-  }
-
   Future<void> _load() async {
     setState(() {
       _loading = true;
@@ -337,26 +992,40 @@ class _PublicEventScreenState extends State<PublicEventScreen> {
     try {
       final d = await _service.fetchEvent(widget.publicHash);
       if (!mounted) return;
-      final eventJson = (d['event'] as Map?)?.cast<String, dynamic>() ?? <String, dynamic>{};
+      final eventJson =
+          (d['event'] as Map?)?.cast<String, dynamic>() ?? <String, dynamic>{};
       final eventModel = PublicEvent.fromJson(eventJson);
       final gc = eventModel.gameCount;
       final parts = (d['participants'] is List)
           ? (d['participants'] as List)
-              .whereType<Map>()
-              .map((e) => PublicParticipant.fromJson(e.cast<String, dynamic>(), gameCount: gc))
-              .toList()
+                .whereType<Map>()
+                .map(
+                  (e) => PublicParticipant.fromJson(
+                    e.cast<String, dynamic>(),
+                    gameCount: gc,
+                  ),
+                )
+                .toList()
           : <PublicParticipant>[];
       final teams = (d['teams'] is List)
           ? (d['teams'] as List)
-              .whereType<Map>()
-              .map((e) => PublicTeam.fromJson(e.cast<String, dynamic>(), gameCount: gc))
-              .toList()
+                .whereType<Map>()
+                .map(
+                  (e) => PublicTeam.fromJson(
+                    e.cast<String, dynamic>(),
+                    gameCount: gc,
+                  ),
+                )
+                .toList()
           : <PublicTeam>[];
 
       setState(() {
         _eventModel = eventModel;
         _participants = parts;
         _teams = teams;
+        _clubName = (d['clubName']?.toString().isNotEmpty == true)
+            ? d['clubName'].toString()
+            : null;
       });
     } on DioException catch (e) {
       if (!mounted) return;
@@ -364,7 +1033,10 @@ class _PublicEventScreenState extends State<PublicEventScreen> {
       if (status == 401 || status == 403) {
         // 인증 만료: 엔트리 화면으로 복귀
         Navigator.of(context).pushReplacement(
-          MaterialPageRoute(builder: (_) => PublicEventEntryScreen(publicHash: widget.publicHash)),
+          MaterialPageRoute(
+            builder: (_) =>
+                PublicEventEntryScreen(publicHash: widget.publicHash),
+          ),
         );
         return;
       } else if (status == 404) {
